Bug 85799

Summary: IconDatabase: Move icon retain/release off of the main thread.
Product: WebKit Reporter: Andreas Kling <kling>
Component: Page LoadingAssignee: Andreas Kling <kling>
Status: RESOLVED FIXED    
Severity: Normal CC: beidson, japhet, levin+threading, webkit.review.bot
Priority: P2 Keywords: InRadar
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Bug Depends on: 86854    
Bug Blocks:    
Attachments:
Description Flags
Patch beidson: review+

Description Andreas Kling 2012-05-07 06:40:37 PDT
<rdar://problem/9507113>

We're seeing quite a few spins below IconDatabase::retainIconForPageURL(), we should avoid blocking the main thread on this operation (and its release sibling.)
Comment 1 Andreas Kling 2012-05-15 17:23:03 PDT
Created attachment 142104 [details]
Patch

Here's one way we can do this- batch up the retain/release operations and execute them on the sync thread.
Comment 2 Brady Eidson 2012-05-17 13:06:51 PDT
Comment on attachment 142104 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=142104&action=review

> Source/WebCore/loader/icon/IconDatabase.cpp:1513
> +
> +    // NOTE: The caller is assumed to hold m_urlAndIconLock.
> +

In the past I thought we had a way to ASSERT this.

Do we still?
Comment 3 Andreas Kling 2012-05-17 14:49:10 PDT
Committed r117501: <http://trac.webkit.org/changeset/117501>